package dev.fitko.fitconnect.api.domain.model.metadata;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import dev.fitko.fitconnect.api.domain.model.metadata.payment.PaymentInformation;
import dev.fitko.fitconnect.api.domain.model.replychannel.ReplyChannel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@EqualsAndHashCode
@AllArgsConstructor
@NoArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Metadata {

    @JsonProperty("$schema")
    private String schema;

    private ContentStructure contentStructure;

    private PublicServiceType publicServiceType;

    private List<AuthenticationInformation> authenticationInformation;

    private PaymentInformation paymentInformation;

    private ReplyChannel replyChannel;

    private AdditionalReferenceInfo additionalReferenceInfo;
}
