package dev.fitko.fitconnect.api.domain.model.replychannel;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ReplyChannel {

    @JsonProperty("deMail")
    private DeMail deMail;

    @JsonProperty("elster")
    private Elster elster;

    @JsonProperty("eMail")
    private Email eMail;

    @JsonProperty("fink")
    private Fink fink;

    public static ReplyChannel fromFink(final String finkPostboxRef, final String host) {
        return new ReplyChannel(null, null, null, new Fink(finkPostboxRef, host));
    }

    public static ReplyChannel fromEmailWithPgp(final String address, final String pgpPublicKey) {
        return new ReplyChannel(null, null, new Email(address, true, pgpPublicKey), null);
    }

    public static ReplyChannel fromEmail(final String address) {
        return new ReplyChannel(null, null, new Email(address, false, null), null);
    }

    public static ReplyChannel fromDeMail(final String address) {
        return new ReplyChannel(new DeMail(address), null, null, null);
    }

    public static ReplyChannel fromElster(final String accountId, final String deliveryTicket, final String reference) {
        return new ReplyChannel(null, new Elster(accountId, deliveryTicket, reference), null, null);
    }
}

